Bug 28493 - pthreads sighandler broken sigcontext passing
pthreads sighandler broken sigcontext passing
Status: CLOSED RAWHIDE
Product: Red Hat Linux
Classification: Retired
Component: glibc (Show other bugs)
7.0
i386 Linux
high Severity high
: ---
: ---
Assigned To: Jakub Jelinek
Aaron Brown
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2001-02-20 15:16 EST by Jesse Off
Modified: 2005-10-31 17:00 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2001-02-20 15:16:10 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jesse Off 2001-02-20 15:16:06 EST
If you set up a signal handler in pthreads and modify the struct 
sigcontext passed in, your changes to that struct are discarded.  For 
instance, modifying context.eip to point to a new function works as you 
would expect in a non-pthreads app, but does not work in pthreads.

Investigation shows that pthreads sets up its own signal handler that then 
copies the real struct sigcontext before passing it to the user 
sighandler.  The user sighandler's struct sigcontext never makes it back 
to the kernel.
Comment 1 Jakub Jelinek 2001-03-21 07:57:05 EST
Should be fixed in glibc-2.2.2-7.

Note You need to log in before you can comment on or make changes to this bug.